#import python useful stuff
import argparse
from sys import *
import os
import time

#import all nesseccary files within this project
from easyTwoKatan import *
from utilities import *

# get external paramters
parser = argparse.ArgumentParser()
# central switches
parser.add_argument('--faultRound', '-r', default=237, type=int,
                    help='Number of the round in which the fault is inserted')
parser.add_argument('--keyGen', '-k', default=0, type=int, 
                    help="1 for standard key, 0 for rnd")

#evalute external parameters
args = parser.parse_args()
faultRound = args.faultRound
ckey = args.keyGen

#################################################################################
# tell the world what we are doing
startTime=str(time.strftime("%Y-%m-%d %H:%M:%S"))
print "start at", time.strftime("%Y-%m-%d %H:%M:%S"), "with parameters"
print prettyDictStr(vars(args))
print
sys.stdout.flush()

#################################################################################

# key and plain text setup
if ckey==1: KE = [0 if ((a % 3) == 0) or ((a % 7) == 0) else 1 for a in xrange(80)] #standard key
#if ckey==1: KE = [GF(2)(1) for _ in xrange(80)] #1 key
else: KE = [GF(2).random_element() for _ in xrange(80)]# random key
plain = [GF(2).random_element() for _ in range(80)]

#fault setup
fault_pos = ZZ.random_element(32)
print 'position is: ', fault_pos
faultVec=[] 
Fbit1=0;Fbit2=0;Fbit3=0
while (Fbit1==0 and Fbit2==0 and Fbit3==0) or (fault_pos==0 and Fbit2==0 and Fbit3==0) or (fault_pos==31 and Fbit1==0 and Fbit2==0):
  Fbit1,Fbit2,Fbit3 = [GF(2).random_element() for _ in range(3)]
if fault_pos==0:
  if Fbit2==1: faultVec.append(fault_pos)
  if Fbit3==1: faultVec.append(fault_pos + 1)
elif fault_pos==31:
  if Fbit1==1: faultVec.append(fault_pos - 1)
  if Fbit2==1: faultVec.append(fault_pos)
else:
  if Fbit1==1: faultVec.append(fault_pos - 1)
  if Fbit2==1: faultVec.append(fault_pos)
  if Fbit3==1: faultVec.append(fault_pos + 1)
print 'the fault vector is:', faultVec

origC = Katan32enc(plain, 254, KE)
faultC = Katan32faultVec(plain, faultVec, 254, faultRound, KE)

#getting the guessed faultTryVec
faultTryVector = twoKatanDec(origC, faultC, faultRound)
#converting the register to our format
faultTryVec = []
for i in range(32):
  if faultTryVector[i] == 1: faultTryVec.append(i)

print 'faultVector is:', faultVec
print 'faultVector try:', faultTryVec
faultVec = sorted(faultVec)
faultTryVec = sorted(faultTryVec)
if faultRound > 245:
  if faultTryVec == faultVec: accept=1
  else: accept=0
else:
  if len(faultTryVec) > 3: 
    accept=0
  elif len(faultTryVec) == 3: 
    if faultTryVec[1]-faultTryVec[0] == 1 and faultTryVec[2]-faultTryVec[1] == 1: 
      if faultTryVec[1] == fault_pos: 
        accept = 1
      else: accept = 0
    else: accept = 0
  elif len(faultTryVec) == 2:
    if faultTryVec[1]-faultTryVec[0] == 1:
      if faultTryVec[0] == fault_pos or faultTryVec[1] == fault_pos: accept=1
      else: accept = 0
    elif faultTryVec[1]-faultTryVec[0] == 2: 
      if (faultTryVec[0] + faultTryVec[1])/2 == fault_pos: accept = 1
      else: accept = 0
    else: accept = 0
  else: 
    if abs(fault_pos - faultTryVec[0]) < 3: accept = 1
    else: accept = 0

# output the full statistic at the end of the file
print "start at", startTime
endTime = time.strftime("%Y-%m-%d %H:%M:%S")
# convert the time
startTimeStruct = time.strptime(startTime, "%Y-%m-%d %H:%M:%S")
endTimeStruct = time.strptime(endTime, "%Y-%m-%d %H:%M:%S")
timeDiff = time.mktime(endTimeStruct) - time.mktime(startTimeStruct)
timeDiff = prettyTimeStr(timeDiff)
print "end at", endTime
print "used time", timeDiff

print "accept key", accept
print 'faultVector was:', faultVec
print 'faultVector try:', faultTryVec
print "faultRound=%d"%faultRound,
print "faultRoundDelta=%d"%(254-faultRound),


print

